<?php

/**
 * supprime un membres d'un groupe depuis sa fiche
 * @Version 12-2018
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: annu
 * file: del_user_group_direct.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("lang.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
echo header_authorize($config);
include_once "ldap.inc.php";
include "ihm.inc.php";

require_once ("lang.inc.php");
bindtextdomain('se4-core', "/var/www/sambaedu/locale");
textdomain('se4-core');

// Aide
$_SESSION["pageaide"] = "Annuaire";

echo "<h1>" . gettext("Annuaire") . "</h1>\n";

$cn_user = $_GET["cn_user"] ?? "";
if ($cn_user == "") {
    echo "<p>ERREUR : Il faut choisir un nom</p>\n";
    include ("pdp.inc.php");
    die();
}

$dn_group = $_GET["dn_group"] ?? "";
if ($dn_group == "") {
    echo "<p>ERREUR : Il faut choisir un groupe</p>\n";
    include ("pdp.inc.php");
    die();
}

aff_trailer("3");

if (! have_right($config, "Annu_is_admin")) {
    echo ("Vous n'avez pas les droits suffisants pour acc&#233;der &#224; cette fonction");
    include ("pdp.inc.php");
    die();
}

// cas d'un groupe principal
$group = search_ad($config, $dn_group);
$sam_group = $group[0]['samaccountname'];
if ($sam_group == "Eleves" || $sam_group == "Profs" || $sam_group == "Administratifs") {

    $user = search_user($config, $cn_user);
    $dn_groups = $user['memberof'];
    $list_current_groups = array();
    $rights_branch = $config['dn']['rights'];
    if (isset($user['memberof'])) {
        foreach ($user['memberof'] as $line) {
            if (! preg_match("/$rights_branch/i", $line)) {
                $list_current_groups[] = $line;
            }
        }
    }
    $ReturnCode = True;
    foreach ($list_current_groups as $dn) {
        $ReturnCode &= groupdelmember($config, $cn_user, $sam_group);
    }
} else {
    // suppression del'utilisateurs selectionné
    $ReturnCode = groupdelmember($config, $cn_user, $sam_group); // . $config['suffix']);
}
// Compte rendu de suppression

if ($ReturnCode) {
    echo "<div class=error_msg>
                     <a href='people.php?cn=$cn_user'>$cn_user </a>" . gettext(" a &#233;t&#233; supprim&#233; du groupe") . "
                      <font color='#0080ff'><A href='group.php?filter=$dn_group'>$sam_group</A></font>" . gettext(" avec succ&#232;s.") . "</div><br>\n";
} else {
    echo "<div class=error_msg>";
    echo gettext("Echec") . ", " . $cn_user . gettext(" n'a pas &#233;t&#233; supprim&#233; du groupe") . "
        <font color='#0080ff'>$sam_group</font>

                </div><BR>\n";
}
include ("pdp.inc.php");
?>