<?php

/**
 * Reinitialisation/Modification des mots de passe
 * @Version 02/2020 - keyser
 * @Projet SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: /
 * file: reinit_mdp.php
 */
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("lang.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
echo header_authorize($config);
require ("ihm.inc.php");
require ("fonc_outils.inc.php");
require ("ent.inc.php");

bindtextdomain('sambaedu-core', "/var/www/sambaedu/locale");
textdomain('sambaedu-core');

// aide en ligne
$_SESSION["pageaide"] = "Annuaire";
$force = $_POST['force'] ?? "false";
if ($force == "true") {
    $force = true;
} else {
    $force = false;
}

$change = $_POST['change'] ?? "true";
if ($change == "true") {
    $change = true;
} else {
    $change = false;
}
$etab = $_POST['uai'] ?? 0;

// debug_var();

if (! have_right($config, "Annu_is_admin|password_is_admin")) {
    die(gettext("Vous n'avez pas les droits suffisants pour acc&#233;der &#224; cette fonction") . "</BODY></HTML>");
}
echo "<h1>" . gettext("R&#233;initialisation/modification de mots de passe") . "</h1>\n";
$pwdPolicy = $config['pwdPolicy'];

// ==========================================================
// Phase de choix des parametres
// echo "<center>\n";
if (! isset($_POST['is_posted'])) {
    // echo "<center>\n";
    echo "<form action=\"" . $_SERVER['PHP_SELF'] . "\" enctype='multipart/form-data' method=\"post\">\n";

    echo "<p>Cette page est destin&#233;e &#224; r&#233;initialiser/modifier les mots de passe par lots.</p>\n";

    $etabs = list_etabs($config);
    $etabs[0] = "Domaine entier";
    if (count($etabs) > 1 && ! isset($config['etab_ou'])) {
        $choix = "<table><tr><td>Choisir l'établissement à administrer <br>";
        $choix .= "<SELECT NAME=\"uai\" SIZE=\"1\" onchange=submit()>";
        foreach ($etabs as $e) {
            $choix .= "<option value=\"" . $e . "\"";
            if ($etab == $e) {
                $choix .= " selected";
            }
            $choix .= ">" . etab_to_name($config, $e) . "\n";
            $choix .= "</option>";
        }
        $choix .= "</SELECT></td></tr></table>\n";
        echo $choix;
    } // else {
    if (empty($config['etab_ou']) && ! empty($etab)) {
        $config['etab_ou'] = $etab;
        $config = get_config($config, true, $etab);
    }
    if (! empty($config['etab_ou']) || count($etabs) == 1 )  {
        echo "<p>Vous pouvez&nbsp;:</p>\n";
        echo "<table summary='Choix du mode'>\n";
        echo "<tr>\n";
        echo "<select name=force>";
        echo "<option value=true ";
        if ($force) {
            echo " selected";
        }
        echo ">reinitialiser tous les utilisateurs selectionnés</option>";
        echo "<option value=false ";
        if (! $force) {
            echo " selected";
        }
        echo ">reinitialiser uniquement les utilisateurs sélectionnés non activés</option>";
        echo "</select>";
        echo "</span></td>\n";
        echo "</tr>\n";
        echo "<tr>\n";
        echo "<select name=change>";
        echo "<option value=true ";
        if ($change) {
            echo " selected";
        }
        echo ">fixer un code d'activation à changer</option>";
        echo "<option value=false ";
        if (! $change) {
            echo " selected";
        }
        echo ">imposer un mot de passe définitif (DANGER)</option>";
        echo "</select>";
        echo "</span></td>\n";
        echo "</tr>\n";
        echo "</table>\n";

        echo "<div id='div_choix_groupes'>\n";
        affiche_all_groups($config, "left", "user");

        echo "<div id=\"attribution\" align='center'>\n";
        echo "<input type=\"hidden\" name=\"is_posted\" value=\"1\">\n";
        echo "<input type=\"hidden\" name=\"uai\" value=\"" . $etab . "\">\n";
        // echo "<input type=\"submit\" value=\"" . gettext("Valider") . "\">\n";
        echo "<input type=\"reset\" value=\"" . gettext("Annuler") . "\">\n";
        echo "</div>\n";

        echo "</div>\n";
    }
    echo "<div id=\"div_validation\" align='center'>\n";
    echo "<input type=\"submit\" value=\"" . gettext("Valider") . "\">\n";
    echo "</div>\n";

    echo "</form>\n";

    include ("pdp.inc.php");
    die();
}
// ==========================================================

// Phase de traitement

// echo "<center>\n";

$classe_gr = isset($_POST['classe_gr']) ? $_POST['classe_gr'] : array();
$equipe_gr = isset($_POST['equipe_gr']) ? $_POST['equipe_gr'] : array();
$matiere_gr = isset($_POST['matiere_gr']) ? $_POST['matiere_gr'] : array();
$autres_gr = isset($_POST['autres_gr']) ? $_POST['autres_gr'] : array();
if (empty($config['etab_ou']) && ! empty($etab)) {
    $config['etab_ou'] = $etab;
    $config = get_config($config, true, $etab);
}

// On lance l'operation pour chaque groupe demande !!!
$listing = [];
if (count($classe_gr)) {
    foreach ($classe_gr as $grp) {
        echo "<h4>" . gettext("R&#233;initialisation des mots de passe pour les membres du groupe " . $grp . "&nbsp;:") . "</h4>\n";
        echo "<pre class='listing'>";
        $members = list_members_group($config, $grp);
        foreach ($members as $user) {
            echo reinit_passwd($config, $user, $listing, $force, $change);
        }
        echo "</pre>\n";
        echo "<hr />\n";
    }
}

if (count($equipe_gr)) {
    foreach ($equipe_gr as $grp) {
        echo "<h4>" . gettext("R&#233;initialisation des mots de passe pour les membres du groupe " . $grp . "&nbsp;:") . "</h4>\n";
        echo "<pre class='listing'>";
        $members = list_members_group($config, $grp);
        foreach ($members as $user) {
            echo reinit_passwd($config, $user, $listing, $force, $change);
        }
        echo "</pre>\n";
        echo "<hr />\n";
    }
}

if (count($matiere_gr)) {
    foreach ($matiere_gr as $grp) {
        echo "<h4>" . gettext("R&#233;initialisation des mots de passe pour les membres du groupe " . $grp . "&nbsp;:") . "</h4>\n";
        echo "<pre class='listing'>";
        $members = list_members_group($config, $grp);
        foreach ($members as $user) {
            echo reinit_passwd($config, $user, $listing, $force, $change);
        }
        echo "</pre>\n";
        echo "<hr />\n";
    }
}

if (count($autres_gr)) {
    foreach ($autres_gr as $grp) {
        echo "<h4>" . gettext("R&#233;initialisation des mots de passe pour les membres du groupe " . $grp . "&nbsp;:") . "</h4>\n";
        echo "<pre class='listing'>";
        $members = list_members_group($config, $grp);
        foreach ($members as $user) {
            if (empty($config['etab_ou']) || $user['etab'] == $config['etab_ou']) {
                echo reinit_passwd($config, $user, $listing, $force, $change);
            }
        }
        echo "</pre>\n";
        echo "<hr />\n";
    }
}
if (isset($_POST['user'])) {
    echo "<h4>Réinitialisation des mots de passe pour " . $_POST['user'] . "</h4>\n";
    echo "<pre class='listing'>";
    echo reinit_passwd($config, search_user($config, $_POST['user']), $listing, $force, $change);
    echo "</pre>\n";
    echo "<hr />\n";
}

echo "<p><a href='" . $_SERVER['PHP_SELF'] . "'>Retour</a></p>";
// echo "</center>\n";

if (file_exists("/tmp/changement_mdp.csv")) {
    // dédoublonner les utilisateurs qui auraient été modifiés plusieurs fois : garder le dernier uniquement

    if ($hdle = fopen("/tmp/changement_mdp.csv", "r")) {

        $listing = array(
            array()
        ); // une ligne par compte ; le deuxieme parametre est, dans l'ordre nom, prenom, classe (si groupe classe), cn, password
        array_splice($listing, 0, 1);

        while ($data = fgetcsv($hdle, 0, ";")) {
            // nom;prenom;cn;mdp;classe
            $num = count($data);
            if ($num >= 5) {
                $nouveau = array(
                    'nom' => "$data[0]",
                    'pre' => "$data[1]",
                    'cla' => "$data[4]",
                    'cn' => "$data[2]",
                    'pwd' => "$data[3]"
                );
                $doublon = false;
                foreach ($listing as &$key) {
                    if ($key['cn'] == $nouveau['cn']) { // doublon
                        $doublon = true;
                        $key['pwd'] = $nouveau['pwd'];
                        // mettre à jour la classe si besoin ou la conserver
                        if ($nouveau['cla'] != '') {
                            $key['cla'] = $nouveau['cla'];
                        }
                        break;
                    }
                }
                unset($key);

                if (! $doublon) {
                    $listing[] = $nouveau;
                }
            }
        }
        fclose($hdle);
    }
}

echo generate_listing($listing);

include ("pdp.inc.php");

?>