<?php

/**

 * Page pour l'authentification
 * @Version $Id$
 * @Projet LCS / SambaEdu
 * @Auteurs Equipe Sambaedu
 * @Licence Distribue sous la licence GPL
 * @Repertoire: /
 * file: auth.php
 *
 */

// Initialisation:
// $error = 0;
require_once 'config.inc.php';
$config = get_config();
require_once 'ldap.inc.php';
require_once 'functions.inc.php';
require 'test_dates.inc.php';

require_once 'lang.inc.php';
bindtextdomain('se4-core', "/var/www/sambaedu/locale");
textdomain('se4-core');
$error = $_GET['error'] ?? "";
// Pas de fichier entête donc on place ici HTMLPurifier
require_once ("includes/traitement_data.inc.php");

$etab_choix = $_POST['etab'] ?? $_GET['etab'] ?? $config['etab_ou'] ?? 0;
$etab = $config['etab_ou'] ?? 0;

$etabs = activated_etabs($config);
$index = array_search($etab_choix, array_column($etabs, 'uai'));

if (! empty($etab_choix) && $etab_choix != $etab && $index !== false && $etabs[$index]['activated']) {
    header("Location:/" . $etab_choix . "/auth.php");
}
$choix = "";
if ($etab == 0) {
    // $etabs = list_etabs($config);
    // $etabs[0] = 0;
    if (count($etabs) > 1) {
        $choix .= "<table><tr><td>Choisir l'établissement à administrer <br>";
        $choix .= "<SELECT NAME=\"etab\" SIZE=\"1\" onchange=submit()>";
        foreach ($etabs as $e) {
            $choix .= "<option value=\"" . $e['uai'] . "\"";
            if ($etab == $e['uai']) {
                $choix .= " selected";
            }
            if ($e['uai'] == 0) {
                $choix .= ">Domaine entier\n";
            } else {
                $choix .= ">" . $e['uai'] . " " . etab_to_name($config, $e['uai']);
                if (! $e['activated']) {
                    $choix .= " <b>virtuel</b>";
                }
                $choix .= "\n";
                $choix .= "</option>";
            }
        }
        $choix .= "</SELECT></td></tr></table>\n";
    }
}

// $request = $_GET["request"] ?? "";
/*
 * On limite $request à index.php
 * pour empêcher le phishing
 */
$request = "index.php";

$al = $_GET["al"] ?? 0;
$login_name = $_POST["login"] ?? "";

// @TODO prendre en compte $etab pour la branche ou le serveur

if ($al != 0 && (! empty($login_name)) && isset($_POST["passwd"])) {
    if ($etab == 0) {
        $config = get_config($config, true, true);
    }
    if (open_session($config, $login_name, $_POST["passwd"], @$_POST["newpasswd"])) {
        $home = search_user($config, $login_name)['etab'];
        if (! empty($home) && ! empty($etab) && $home != $etab) {
            echo '<script language="javascript">
    window.location.href = "/' . $etab . '/' . $request . '";
</script>';
        } else {
            echo '<script language="javascript">
    top.location.href = "' . $request . '";
</script>';
        }
        // exit();
    } else {
        if (empty($login_name)) {
            header("Location:auth.php?al=0&error=2");
            exit();
        } else {
            header("Location:auth.php?al=0&error=1");
            exit();
        }
    }
} else {
    $texte = '
<!DOCTYPE html>
<HTML>
<HEAD>
 <STYLE type="text/css">
body {
	background: url(/elements/images/fond_SE3.png) #f0f1f6 bottom right
	no-repeat fixed;
}
</STYLE>
</head>
<body>
';
    $texte .= gettext("<P>Afin de pouvoir acc&#233;der à l'interface <EM>SambaÉdu</EM>, veuillez indiquer votre identifiant et votre mot de passe sur le r&#233;seau.\n");
    $texte .= "<form name = 'auth' action='auth.php?al=1&request=" . rawurlencode($request) . "' method='post' >\n";
    $texte .= "<table><tr>";
    $texte .= $choix;
    $texte .= "<td>";
    if ($etab == 0) {
        $texte .= gettext("Identifiant") . " :</td><td><INPUT TYPE='text' NAME='login' SIZE='20' MAXLENGTH='30'><BR>\n";
    } else {
        $texte .= gettext("Identifiant pour ") . " $etab :</td><td><INPUT TYPE='text' NAME='login' SIZE='20' MAXLENGTH='30'><BR>\n";
    }
    $texte .= "</td></tr><tr><td>\n";
    $texte .= gettext("Mot de passe") . " :</td><td><INPUT TYPE='password' NAME='passwd' SIZE='20' MAXLENGTH='20'><BR>\n";
    // $texte .= "</td></tr><tr align=\"right\"><td></td><td>\n";
    $texte .= "<input type='hidden' name='string_auth' value=''>";
    $texte .= "<input type='hidden' name='time' value=''>";
    $texte .= "<input type='hidden' name='client_ip' value='" . remote_ip() . "'>";
    $texte .= "<input type='hidden' name='timestamp' value='" . time() . "'>";
    $texte .= "<INPUT TYPE='submit' VALUE='" . gettext("Valider") . "'><BR>\n";
    $texte .= "</td></tr></table>\n";
    $texte .= "</form>\n";

    mktable("<STRONG>Authentification...</STRONG>", $texte);
    if ($error == 1) {
        echo "<div class='alert_msg'>" . gettext("Erreur d'authentification !") . "</div>";
    }

    // Test de l'ecart entre la date du serveur et la date du client
    // S'il y a plus de 200 secondes d'ecart, on affiche une alert() javascript:
    test_et_alerte_dates();

    include ("includes/pdp2.inc.php");
}
?>
