<?php

/**

 * Configuration du serveur dhcp

 * @Projet SambaEdu

 * @auteurs  GrosQuicK   eric.mercier@crdp.ac-versailles.fr denis.bonnenfant

 * @note

 * @Licence  Distribue sous la licence GPL

 */

/**
 *
 * @Repertoire: dhcp
 *
 * file: config.php
 */

// init html code
include "config.inc.php";
require "ldap.inc.php";
require_once ("functions.inc.php");
require_once ("lang.inc.php");
require_once ("traitement_data.inc.php");
$config = get_config();
echo header_authorize($config);
include_once "ldap.inc.php";
include "ihm.inc.php";
require_once "dhcpd.inc.php";
require_once "sites.inc.php";

$action = $_POST['action'] ?? '';
$vlan_actif = $_POST['vlan'] ?? '0';

if (have_right($config, "se3_is_admin")) {
    $error = array();
    // aide
    $_SESSION["pageaide"] = "Le_module_DHCP#Configuration_du_serveur_DHCP";

    $content = "<h1>" . gettext("Paramètres du serveur DHCP") . "</h1>";
    switch ($action) {
        case '':
        case 'index':
            $content .= dhcp_config_form($config, $vlan_actif, $error);
            $content .= dhcpd_status();
            break;

        case 'newconfig':
            $error = dhcp_update_config($config, $vlan_actif);
            if ($error == "") {
                exec("sudo /usr/share/sambaedu/sbin/make_dhcpd_conf.sh");
                echo "<meta http-equiv='refresh' content='0'>";
            }
            $content .= dhcp_config_form($config, $vlan_actif, $error);
            $content .= dhcpd_status();
            break;
        case 'restart':
            dhcpd_restart();
            $content .= dhcp_config_form($config, $vlan_actif, $error);
            $content .= dhcpd_status();
            break;
        case 'stop':
            dhcpd_stop();
            $content .= dhcp_config_form($config, $vlan_actif, $error);
            $content .= dhcpd_status();
            break;
        default:
            $title = '';
            $content = '';
            return;
    }
    print "$content\n";
} else {
    print(gettext("Vous n'avez pas les droits n&#233;cessaires pour ouvrir cette page..."));
}

// Footer
include ("pdp.inc.php");
?>