<?php

function export_asm($config)
{
    $tmp_asm = "/tmp/asm";

    $etabs = search_ad($config, "*", "etablissement");
    $ad_users = search_ad($config, "*", "user");
    // entetes
    $locations[] = '"location id,location name"';
    $students[] = '"person_id","person_number","first_name","middle_name","last_name","grade_level","email_address","sis_username","password_policy","location_id"';
    $staff[] = '"person_id","person_number","first_name","middle_name","last_name","email_address","sis_username","location_id"';
    $e_classes = '"course_id","course_number","course_name","instructor_id",';
    for ($i = 2; $i < 250; $i ++) {
        $e_classes .= '"instructor_id_' . $i . '",';
    }
    $e_classes .= '"location_id"';
    $classes[] = $e_classes;

    foreach ($etabs as $etab) {
        $locations[] = '"' . strtoupper($etab['cn']) . '","' . $etab['description'] . '"';
        for ($i = 1; $i < 10; $i ++) {
            $ad_users[] = [
                'Id ASM' => strtoupper($etab['cn']) . "_PROF" . $i,
                'Id GPEI' => strtoupper($etab['cn']) . "_PROF" . $i,
                'nom' => strtoupper($etab['cn']),
                'etab' => strtoupper($etab['cn']),
                'prenom' => "PROF" . $i,
                'email' => "",
                'cn' => "",
                'memberof' => [
                    "CN=Profs,OU=Groups"
                ]
            ];
        }
    }
    $rosters[] = '"roster_id","class_id","student_id"';
    $cours = [];
    foreach ($ad_users as $user) {
        $user['Id GPEI'] = $user['Id GPEI'] ?? to_guid($user['objectguid']);
        if (empty($user['Id ASM'])) {
            $user['Id ASM'] = $user['Id GPEI'];
        }
        if ($user['etab'] != 0) {
            foreach ($user['memberof'] as $groupe) {
                $m = array();
                if (preg_match("/CN=(Eleves|Profs|Administratifs),OU=Groups.*/", $groupe, $m)) {
                    if ($m[1] == "Eleves") {
                        $students[] = '"' . $user['Id ASM'] . '","' . $user['Id GPEI'] . '","' . $user['prenom'] . '","","' . $user['nom'] . '","3","' . $user['email'] . '","' . $user['cn'] . '","4","' . strtoupper($user['etab']) . '"';
                    } elseif ($m[1] == "Profs") {
                        $staff[] = '"' . $user['Id ASM'] . '","' . $user['Id GPEI'] . '","' . $user['prenom'] . '","","' . $user['nom'] . '","' . $user['email'] . '","' . $user['cn'] . '","' . strtoupper($user['etab']) . '"';
                    }
                }
                $m = array();
                if (preg_match("/^CN=(Classe|Equipe|Cours)_(.*),OU=(Classes|Equipes|Cours),.*/i", $groupe, $m)) {
                    if ($m[1] == "Equipe") {
                        $id = strtoupper($user['etab']) . "_" . $m[2];
                        $cours[$id]['d'] = '"' . $id . '","' . $id . '",';
                        $cours[$id]['f'] = '"' . strtoupper($user['etab']) . '"';
                        $cours[$id]['p'][] = '"' . $user['Id ASM'] . '",';
                        if (! isset($cours[$id]['q'])) {
                            for ($i = 1; $i < 10; $i ++) {
                                $cours[$id]['q'][] = '"' . strtoupper($user['etab']) . '_PROF' . $i . '",';
                            }
                        }
                    } else {
                        $rosters[] = '"' . strtoupper($user['etab']) . '_' . $m[2] . '_' . $user['Id ASM'] . '","' . strtoupper($user['etab']) . '_' . $m[2] . '","' . $user['Id ASM'] . '"';
                    }
                }
            }
        }
    }
    file_put_contents($tmp_asm . "/locations.csv", implode("\n", $locations));
    file_put_contents($tmp_asm . "/staff.csv", implode("\n", $staff));
    file_put_contents($tmp_asm . "/students.csv", implode("\n", $students));
    file_put_contents($tmp_asm . "/rosters.csv", implode("\n", $rosters));
    foreach ($cours as $id => $l) {
        $ligne = '"' . $id . '",' . $l['d'];
        foreach ($l['p'] as $p) {
            $ligne .= $p;
        }
        foreach ($l['q'] as $p) {
            $ligne .= $p;
        }
        $ligne .= $l['f'];
        $classes[] = $ligne;
    }
    file_put_contents($tmp_asm . "/classes.csv", implode("\n", $classes));

    return "Export ASM : " . count($staff) . " Profs, " . count($students);
}

function sync_asm($config)
{
    $html = "<h1>Import asm</h1>\n";
    // @TODO !!!
    // récupération non fonctionnelle

    if (! empty($config['asm_url'])) {
        // on est sur le central
        $rsync = "rsync -e \"ssh -i /etc/sambaedu/id_rsa\" " . $config['asm_url'] . "/tmp/gpei/";
        system($rsync);
        $list = scandir("/tmp/gpei/");
        if (file_exists("/tmp/gpei/list.json")) {
            $oldlist = json_decode(file_get_contents("/tmp/gpei/list.json"));
        } else {
            $oldlist = [];
        }
        $new = array_diff($list, $oldlist);
        $html .= "Récupération de " . count($new) . " fichiers gpei<br>\n";
        foreach (list_etabs($config) as $etab) {
            if (fping("se4fs-" . $etab)) {
                foreach ($new as $gpei) {
                    $scp = "scp -i /etc/sambaedu/id_rsa " . $gpei . " root@se4fs-" . $etab . ":" . $gpei;
                    system($scp);
                }
                $html .= " envoi au serveur " . $etab . "<br>\n";
            }
        }
        $file = "";
    } else {
        $list = scandir("/tmp/gpei/");
        $complet = $delta = [];
        foreach ($list as $gpei) {
            preg_match("/^.*_GPEI_(Complet|Delta)_([0-9]{8})\.zip$/", $gpei, $m);
            if ($m[1] == "Complet") {
                $complet[] = $gpei;
            } else {
                $delta[] = $gpei;
            }
        }
        sort($complet, SORT_DESC);
        if (count($complet) > 0) {
            // on prend le plus récent complet pour commencer
            $file = array_shift($complet);
        } elseif (count($delta) > 0) {
            sort($delta, SORT_ASC);
            $file = array_shift($delta);
        } else {
            $file = "";
        }
    }
    if (! empty($file)) {
        $html .= import_archive($config, $file, "gpei");
        unlink($file);
    }
    return $html;
}
?>